import { ICLIArguments } from './types';
/**
 * Like regular console.log, but better.
 * @param message
 */
export declare function log(message: string): void;
/**
 * Makes success feel even sweeter.
 * @param text
 */
export declare function success(text: string): void;
/**
 * Logs an error all pretty.
 * @param err
 */
export declare function error(err: Error | string): void;
/**
 * Spins while doing work. Stops when done.
 * @param text
 * @param fn
 */
export declare function spinWhile<T>(text: string, fn: () => Promise<T>): Promise<T>;
/**
 * Super simple argument parser.
 * @param argv
 */
export declare function parseArguments(argv: Array<string>): ICLIArguments;
