"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPackageJSONFileService = void 0;
var fs = __importStar(require("fs"));
var util_1 = require("./util");
var detect_indent_1 = __importDefault(require("detect-indent"));
var statAsync = (0, util_1.promisify)(fs.stat);
var readFileAsync = (0, util_1.promisify)(fs.readFile);
var writeFileAsync = (0, util_1.promisify)(fs.writeFile);
function createPackageJSONFileService() {
    var _this = this;
    return {
        readPackageFile: function (filePath) { return __awaiter(_this, void 0, void 0, function () {
            var contents;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, readFileContents(filePath)];
                    case 1:
                        contents = _a.sent();
                        return [2 /*return*/, JSON.parse(contents)];
                }
            });
        }); },
        writePackageFile: function (filePath, fileContent) { return __awaiter(_this, void 0, void 0, function () {
            var contents, indent, trailingNewline, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, readFileContents(filePath)];
                    case 1:
                        contents = _a.sent();
                        indent = (0, detect_indent_1.default)(contents).indent;
                        trailingNewline = contents.length
                            ? contents[contents.length - 1] === '\n'
                            : false;
                        data = JSON.stringify(fileContent, null, indent /* istanbul ignore next */ || '  ');
                        return [4 /*yield*/, writeFileAsync(filePath, data + (trailingNewline ? '\n' : ''))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); },
    };
}
exports.createPackageJSONFileService = createPackageJSONFileService;
function readFileContents(filePath) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, assertFile(filePath)];
                case 1:
                    _a.sent();
                    return [2 /*return*/, readFileAsync(filePath, 'utf-8').then(function (x) { return x.toString(); })];
            }
        });
    });
}
function assertFile(filePath) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, existsAsync(filePath)];
                case 1:
                    if (!(_a.sent())) {
                        throw new Error("".concat(filePath, " does not exist."));
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function existsAsync(filePath) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, statAsync(filePath)
                    .then(function () { return true; })
                    .catch(function (err) {
                    /* istanbul ignore else */
                    if (err.code === 'ENOENT') {
                        return false;
                    }
                    /* istanbul ignore next */
                    throw err;
                })];
        });
    });
}
//# sourceMappingURL=package-json-file-service.js.map